;; TODO/BUGS:
;; - Figure out how to run the android connection session
;; - Make new appearence of *Messages* buffer get captured in k-tabbar
;; - Figure out how mode:minibuffer-inactive gets into k-tabbar and
;;   prevent it


;;

(defun k::backtrace ()
  "Produce a backtrace as a message."
  (message "%s"
	   (with-temp-buffer
	     (let ((standard-output (current-buffer)))
	       (backtrace)
	       (buffer-string)))))


(advice-remove 'shell #'k-shell::shell)

(defvar k-frame::emacsclient-window nil
  "The selected window of a frame newly created for emacsclient.")

(defun k-frame::server-create-window-system-frame (orig-fun &rest args)
  "Advice function for handling emacsclient windows, so they don't get
  associated with existing buffers."
  (setq k::norecord-buffer (current-buffer)
	k-frame::emacsclient-window
	(frame-selected-window (apply orig-fun args))))

(advice-add 'server-create-window-system-frame :around
	    'k-frame::server-create-window-system-frame)

(defun k-frame::split-for-emacsclient ()
  "Handle split-window when called from emacsclient.  If we are in a new
  frame, return the frame's window, otherwise nil."
  k-frame::emacsclient-window)

(defvar k::in-emacsclient nil
  "Boolean identifying whether we are setting up for emacsclient.")

(defun k-frame::server-process-filter (orig-fun &rest args)
  (let ((k::in-emacsclient t)
	k::norecord-buffer)
    (prog1
	(apply orig-fun args))
    (k-frame::post-command)
    (when k-frame::emacsclient-window
      (k-frame::forget-buffer-visit
       ;; Remove all trace of new frame's original buffer
       k-frame::emacsclient-window  k::norecord-buffer)
      (setq k-frame::emacsclient-window nil))
    (setq last-command this-command) ;; So buffer-placement can work
    ))

(advice-add 'server-process-filter :around 'k-frame::server-process-filter)
    


